#include extreme\_ex_specials;

perkInit()
{
	// perk related precaching
	[[level.ex_PrecacheModel]]("xmodel/bulletproofvest");

	game["mod_protect_hudicon"] = "mod_protect_hudicon";
	[[level.ex_PrecacheShader]](game["mod_protect_hudicon"]);
}

perkInitPost()
{
	// perk related precaching after map load
}

perkAssignDelayed(delay)
{
	self endon("kill_thread");

	if(isDefined(self.pers["isbot"])) return;
	wait( [[level.ex_fpstime]](delay) );

	if(!playerPerkIsLocked("vest", true)) self thread perkAssign(0);
}

perkAssign(delay)
{
	self endon("kill_thread");

	wait( [[level.ex_fpstime]](delay) );

	self thread hudNotifySpecial("vest");
	// moved playerStartUsingPerk("vest") to timer, so player will keep the vest
	// if he dies within 5 seconds after buying it (if keep feature is enabled)
	self.health = 100;
	if(!checkVest()) self attach("xmodel/bulletproofvest", "J_Spine4", false);
	vestTimer();
	if(checkVest()) self detach("xmodel/bulletproofvest", "J_Spine4");
	self thread playerStopUsingPerk("vest", true);
}

checkVest()
{
	vest_attached = false;
	attachedSize = self getAttachSize();
	for(i = 0; i < attachedSize; i++)
	{
		attachedModel = self getAttachModelName(i);
		if(attachedModel == "xmodel/bulletproofvest") vest_attached = true;
	}

	return(vest_attached);
}

vestTimer()
{
	self endon("kill_thread");
	self endon("kill_vest");

	self.ex_vest_protected = true;

	timer = 0;
	while(timer < level.ex_vest_timer)
	{
		self thread hudNotifyProtected();
		wait( [[level.ex_fpstime]](1) );
		timer++;
		if(timer == 5)
		{
			self thread hudNotifySpecialRemove("vest");
			self thread playerStartUsingPerk("vest", false);
		}
	}

	self thread hudNotifyProtectedRemove();
	self.ex_vest_protected = undefined;
}
