
init()
{
	if(!level.ex_toolbox) return;

	level.ex_toolbox_models = [];
	level.ex_toolbox_model = -1;

	count = 0;
	for(;;)
	{
		model_check = [[level.ex_drm]]("ex_toolbox_model_" + count, "", "", "", "string");
		if(model_check == "") return;
		index = level.ex_toolbox_models.size;
		level.ex_toolbox_models[index] = "xmodel/" + model_check;
		[[level.ex_PrecacheModel]](level.ex_toolbox_models[index]);
		count++;
	}
}

main()
{
	level endon("ex_gameover");
	self endon("disconnect");

	count = 0;
	for(;;)
	{
		name_check = [[level.ex_drm]]("ex_toolbox_name_" + count, "", "", "", "string");
		if(name_check == "") return;
		if(name_check == self.name) break;
			else count++;
	}

	name_tools = [[level.ex_drm]]("ex_toolbox_tools_" + count, 0, 0, 64, "int");
	if((name_tools & 1) == 1) self thread toolShowPos();
	if((name_tools & 2) == 2) self thread toolThirdPerson();
	if((name_tools & 4) == 4 && level.ex_toolbox_models.size) self thread toolModelTest();
}

toolShowPos()
{
	level endon("ex_gameover");
	self endon("disconnect");

	if(isDefined(self.pers["tool_showpos"])) return;
	self.pers["tool_showpos"] = true;
	logprint("TOOLBOX: show position tool started for player: " + self.name + "\n");

	meleecount = 0;
	savecount = 0;

	while(1)
	{
		wait( [[level.ex_fpstime]](0.2) );

		origin = self.origin;

		// Position X
		if(!isDefined(self.ex_showposx))
		{
			self.ex_showposx = newClientHudElem(self);
			self.ex_showposx.archived = false;
			self.ex_showposx.horzAlign = "fullscreen";
			self.ex_showposx.vertAlign = "fullscreen";
			self.ex_showposx.alignX = "center";
			self.ex_showposx.alignY = "top";
			self.ex_showposx.x = 250;
			self.ex_showposx.y = 55;
			self.ex_showposx.fontscale = 1.0;
			self.ex_showposx.color = (1, 0, 0);
		}
		self.ex_showposx setValue(origin[0]);

		// Position Y
		if(!isDefined(self.ex_showposy))
		{
			self.ex_showposy = newClientHudElem(self);
			self.ex_showposy.archived = false;
			self.ex_showposy.horzAlign = "fullscreen";
			self.ex_showposy.vertAlign = "fullscreen";
			self.ex_showposy.alignX = "center";
			self.ex_showposy.alignY = "top";
			self.ex_showposy.x = 320;
			self.ex_showposy.y = 55;
			self.ex_showposy.fontscale = 1.0;
			self.ex_showposy.color = (1, 0, 0);
		}
		self.ex_showposy setValue(origin[1]);

		// Position Z
		if(!isDefined(self.ex_showposz))
		{
			self.ex_showposz = newClientHudElem(self);
			self.ex_showposz.archived = false;
			self.ex_showposz.horzAlign = "fullscreen";
			self.ex_showposz.vertAlign = "fullscreen";
			self.ex_showposz.alignX = "center";
			self.ex_showposz.alignY = "top";
			self.ex_showposz.x = 390;
			self.ex_showposz.y = 55;
			self.ex_showposz.fontscale = 1.0;
			self.ex_showposz.color = (1, 0, 0);
		}
		self.ex_showposz setValue(origin[2]);

		angles = self getplayerangles();

		// Angle X
		if(!isDefined(self.ex_showanglex))
		{
			self.ex_showanglex = newClientHudElem(self);
			self.ex_showanglex.archived = false;
			self.ex_showanglex.horzAlign = "fullscreen";
			self.ex_showanglex.vertAlign = "fullscreen";
			self.ex_showanglex.alignX = "center";
			self.ex_showanglex.alignY = "top";
			self.ex_showanglex.x = 250;
			self.ex_showanglex.y = 75;
			self.ex_showanglex.fontscale = 1.0;
			self.ex_showanglex.color = (1, 0, 0);
		}
		self.ex_showanglex setValue(angles[0]);

		// Angle Y
		if(!isDefined(self.ex_showangley))
		{
			self.ex_showangley = newClientHudElem(self);
			self.ex_showangley.archived = false;
			self.ex_showangley.horzAlign = "fullscreen";
			self.ex_showangley.vertAlign = "fullscreen";
			self.ex_showangley.alignX = "center";
			self.ex_showangley.alignY = "top";
			self.ex_showangley.x = 320;
			self.ex_showangley.y = 75;
			self.ex_showangley.fontscale = 1.0;
			self.ex_showangley.color = (1, 0, 0);
		}
		self.ex_showangley setValue(angles[1]);

		// Angle Z
		if(!isDefined(self.ex_showanglez))
		{
			self.ex_showanglez = newClientHudElem(self);
			self.ex_showanglez.archived = false;
			self.ex_showanglez.horzAlign = "fullscreen";
			self.ex_showanglez.vertAlign = "fullscreen";
			self.ex_showanglez.alignX = "center";
			self.ex_showanglez.alignY = "top";
			self.ex_showanglez.x = 390;
			self.ex_showanglez.y = 75;
			self.ex_showanglez.fontscale = 1.0;
			self.ex_showanglez.color = (1, 0, 0);
		}
		self.ex_showanglez setValue(angles[2]);

		// Monitor MELEE key. Reset counter if ADS, sprinting, planting or defusing
		if(self meleeButtonPressed() && !self playerADS() && !self.ex_plantwire && !self.ex_defusewire)
		{
			// Should have held key for 1 second at least
			if(meleecount > 5)
			{
				savecount++;
				logprint("TOOLBOX: [" + savecount + "] " + "origin " + origin + ", " + "angles " + angles + "\n");
				meleecount = 0;
				while(self meleeButtonPressed()) wait( [[level.ex_fpstime]](0.5) );
			}
			else meleecount++;
		}
		else meleecount = 0;
	}
}

toolThirdPerson()
{
	level endon("ex_gameover");
	self endon("disconnect");

	if(isDefined(self.pers["tool_thirdperson"])) return;
	self.pers["tool_thirdperson"] = true;
	logprint("TOOLBOX: third person tool started for player: " + self.name + "\n");

	self.ex_thirdperson = false;
	thirdpersonangle = 0;
	thirdpersonrange = 100;

	meleecount = 0;
	usecount = 0;

	while(1)
	{
		wait( [[level.ex_fpstime]](0.2) );

		// Monitor USE key. Reset counter if ADS, sprinting or rearming
		if(self useButtonPressed() && !self playerADS() && !self.ex_sprinting && !self.handling_mine && !isDefined(self.ex_amc_rearm) && !isDefined(self.ex_ishealing))
		{
			// Should have held key for 1 second at least
			if(usecount > 5)
			{
				if(self.ex_thirdperson)
				{
					thirdpersonrange += 20;
					if(thirdpersonrange > 200)
					{
						thirdpersonrange = 100;
						self setClientCvar("cg_thirdperson", 0);
						self.ex_thirdperson = false;
						usecount = 0;
					}
					else self setClientCvar("cg_thirdpersonrange", thirdpersonrange);
				}
				else
				{
					self setClientCvar("cg_thirdpersonangle", thirdpersonangle);
					self setClientCvar("cg_thirdpersonrange", thirdpersonrange);
					self setClientCvar("cg_thirdperson", 1);
					self.ex_thirdperson = true;
					usecount = 0;
				}
			}
			else usecount++;
		}
		else usecount = 0;

		if(self.ex_thirdperson)
		{
			// Monitor MELEE key. Reset counter if ADS, sprinting, planting or defusing
			if(self meleeButtonPressed() && !self playerADS() && !self.ex_plantwire && !self.ex_defusewire)
			{
				// Should have held key for 1 second at least
				if(meleecount > 5)
				{
					thirdpersonangle += 10;
					if(thirdpersonangle == 360) thirdpersonangle = 0;
					self setClientCvar("cg_thirdpersonangle", thirdpersonangle);
				}
				else meleecount++;
			}
			else meleecount = 0;
		}
	}
}

toolModelTest()
{
	level endon("ex_gameover");
	self endon("disconnect");

	if(isDefined(self.pers["tool_modeltest"])) return;
	self.pers["tool_modeltest"] = true;
	logprint("TOOLBOX: model testing tool started for player: " + self.name + "\n");

	meleecount = 0;

	while(1)
	{
		wait( [[level.ex_fpstime]](0.2) );

		if(!self isOnGround()) continue;

		// Monitor MELEE key. Reset counter if ADS, sprinting, planting or defusing
		if(self meleeButtonPressed() && !self playerADS() && !self.ex_plantwire && !self.ex_defusewire)
		{
			// Should have held key for 1 second at least
			if(meleecount > 5)
			{
				if(!extreme\_ex_utils::tooClose(150, 150, 150, 150)) self thread toolModelCreate();
				while(self meleeButtonPressed()) wait( [[level.ex_fpstime]](0.5) );
				meleecount = 0;
			}
			else meleecount++;
		}
		else meleecount = 0;
	}
}

toolModelCreate()
{
	level.ex_toolbox_model++;
	if(level.ex_toolbox_model >= level.ex_toolbox_models.size) level.ex_toolbox_model = 0;

	model = spawn("script_model", self.origin);
	model setmodel(level.ex_toolbox_models[level.ex_toolbox_model]);
	model.angles = (0, self.angles[1], 0);
	model.owner = self;
	model.team = self.pers["team"];

	model thread toolModelAction();
}

toolModelAction()
{
	ttl = 60;
	while(ttl > 0)
	{
		ttl--;
		wait( [[level.ex_fpstime]](1) );
	}

	self delete();
}

/*******************************************************************************
LOCATORS
*******************************************************************************/
posForward(origin, angles, length)
{
	angles = anglesNormalize(angles);
	forwardvector = anglesToForward(angles);
	origin = origin + [[level.ex_vectorscale]](forwardvector, length);
	return(origin);
}

posBack(origin, angles, length)
{
	angles = anglesNormalize(angles);
	forwardvector = anglesToForward(angles);
	origin = origin + [[level.ex_vectorscale]](forwardvector, 0 - length);
	return(origin);
}

posUp(origin, angles, length)
{
	angles = anglesNormalize(angles);
	forwardvector = anglestoup( (0, angles[1], 0) );
	origin = origin + [[level.ex_vectorscale]](forwardvector, length);
	return(origin);
}

posDown(origin, angles, length)
{
	angles = anglesNormalize(angles);
	forwardvector = anglestoup( (180, angles[1], 0) );
	if(!length)
	{
		forwardpos = origin + ([[level.ex_vectorscale]](forwardvector, 20000));
		trace = bulletTrace(origin, forwardpos, false, undefined);
		if(trace["fraction"] != 1) origin = trace["position"];
			else origin = forwardpos;
	}
	else origin = origin + [[level.ex_vectorscale]](forwardvector, length);
	return(origin);
}

posLeft(origin, angles, length)
{
	angles = anglesNormalize(angles);
	forwardvector = anglestoforward( (0, angles[1] + 90, 0) );
	origin = origin + [[level.ex_vectorscale]](forwardvector, length);
	return(origin);
}

posRight(origin, angles, length)
{
	angles = anglesNormalize(angles);
	forwardvector = anglestoforward( (0, angles[1] - 90, 0) );
	origin = origin + [[level.ex_vectorscale]](forwardvector, length);
	return(origin);
}

/*******************************************************************************
MISC
*******************************************************************************/
angleNormalize(angle)
{
	if(angle) while(angle >= 360) angle -= 360;
		else while(angle <= -360) angle += 360;
	return(angle);
}

anglesNormalize(angles)
{
	pitch = angleNormalize(angles[0]);
	yaw = angleNormalize(angles[1]);
	roll = angleNormalize(angles[2]);
	return( (pitch, yaw, roll) );
}
